import { Accordion as Accordion_2 } from 'radix-ui';
import { AlertDialog as AlertDialog_2 } from 'radix-ui';
import { AspectRatio as AspectRatio_2 } from 'radix-ui';
import { Avatar as Avatar_2 } from 'radix-ui';
import { ButtonProps as ButtonProps_2 } from './button';
import { Checkbox as Checkbox_2 } from 'radix-ui';
import { ClassProp } from 'class-variance-authority/types';
import { Collapsible as Collapsible_2 } from 'radix-ui';
import { ColumnDef } from '@tanstack/react-table';
import { ColumnFiltersState } from '@tanstack/react-table';
import { Consumer } from 'react';
import { Context } from 'react';
import { ContextMenu as ContextMenu_2 } from 'radix-ui';
import { ControllerProps } from 'react-hook-form';
import { DayPicker } from 'react-day-picker';
import { default as default_2 } from 'react';
import { default as default_3 } from 'embla-carousel-react';
import { DetailedHTMLProps } from 'react';
import { Dialog } from 'radix-ui';
import { DialogCloseProps } from '@radix-ui/react-dialog';
import { DialogContentProps } from '@radix-ui/react-dialog';
import { DialogDescriptionProps } from '@radix-ui/react-dialog';
import { DialogOverlayProps } from '@radix-ui/react-dialog';
import { DialogTitleProps } from '@radix-ui/react-dialog';
import { DialogTriggerProps } from '@radix-ui/react-dialog';
import { Drawer as Drawer_2 } from 'vaul';
import { DropdownMenu as DropdownMenu_2 } from 'radix-ui';
import { FC } from 'react';
import { FieldError } from 'react-hook-form';
import { FieldPath } from 'react-hook-form';
import { FieldValues } from 'react-hook-form';
import { FormProviderProps } from 'react-hook-form';
import { ForwardRefExoticComponent } from 'react';
import { HoverCard as HoverCard_2 } from 'radix-ui';
import { HTMLAttributes } from 'react';
import { ImperativePanelHandle } from 'react-resizable-panels';
import { ItemCallback } from 'react-grid-layout';
import { JSX as JSX_2 } from 'react/jsx-runtime';
import { Label } from 'radix-ui';
import { Layout } from 'react-grid-layout';
import { LiHTMLAttributes } from 'react';
import { Menubar as Menubar_2 } from 'radix-ui';
import { NavigationMenu as NavigationMenu_2 } from 'radix-ui';
import { PanelProps } from 'react-resizable-panels';
import { PanelResizeHandleProps } from 'react-resizable-panels';
import { Popover as Popover_2 } from 'radix-ui';
import { Portal } from 'vaul';
import { Progress as Progress_2 } from 'radix-ui';
import { PropsWithChildren } from 'react';
import { RadioGroup as RadioGroup_2 } from 'radix-ui';
import * as React_2 from 'react';
import { ReactNode } from 'react';
import { RefAttributes } from 'react';
import { Scope } from '@radix-ui/react-context';
import { ScrollArea as ScrollArea_2 } from 'radix-ui';
import { Select as Select_2 } from 'radix-ui';
import { Separator as Separator_2 } from 'radix-ui';
import { Slider as Slider_2 } from 'radix-ui';
import { SlotProps } from '@radix-ui/react-slot';
import { SortingState } from '@tanstack/react-table';
import { Switch as Switch_2 } from 'radix-ui';
import { Tabs as Tabs_2 } from 'radix-ui';
import { TdHTMLAttributes } from 'react';
import { ThHTMLAttributes } from 'react';
import { Toaster as Toaster_2 } from 'sonner';
import * as ToggleGroupPrimitive from '@radix-ui/react-toggle-group';
import * as TogglePrimitive from '@radix-ui/react-toggle';
import * as TooltipPrimitive from '@radix-ui/react-tooltip';
import { UseEmblaCarouselType } from 'embla-carousel-react';
import { useForm } from 'react-hook-form';
import { VariantProps } from 'class-variance-authority';
import { VisibilityState } from '@tanstack/react-table';

declare const Accordion: React_2.ForwardRefExoticComponent<(Accordion_2.AccordionSingleProps | Accordion_2.AccordionMultipleProps) & React_2.RefAttributes<HTMLDivElement>>;

declare const AccordionContent: React_2.ForwardRefExoticComponent<Omit<Accordion_2.AccordionContentProps & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const AccordionItem: React_2.ForwardRefExoticComponent<Omit<Accordion_2.AccordionItemProps & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const AccordionTrigger: React_2.ForwardRefExoticComponent<Omit<Accordion_2.AccordionTriggerProps & React_2.RefAttributes<HTMLButtonElement>, "ref"> & React_2.RefAttributes<HTMLButtonElement>>;

declare const Alert: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & VariantProps<(props?: ({
variant?: "default" | "destructive" | null | undefined;
} & ClassProp) | undefined) => string> & RefAttributes<HTMLDivElement>>;

declare const AlertDescription: ForwardRefExoticComponent<HTMLAttributes<HTMLParagraphElement> & RefAttributes<HTMLParagraphElement>>;

declare const AlertDialog: React_2.FC<AlertDialog_2.AlertDialogProps>;

declare const AlertDialogAction: React_2.ForwardRefExoticComponent<Omit<AlertDialog_2.AlertDialogActionProps & React_2.RefAttributes<HTMLButtonElement>, "ref"> & React_2.RefAttributes<HTMLButtonElement>>;

declare const AlertDialogCancel: React_2.ForwardRefExoticComponent<Omit<AlertDialog_2.AlertDialogCancelProps & React_2.RefAttributes<HTMLButtonElement>, "ref"> & React_2.RefAttributes<HTMLButtonElement>>;

declare const AlertDialogContent: React_2.ForwardRefExoticComponent<Omit<AlertDialog_2.AlertDialogContentProps & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const AlertDialogDescription: React_2.ForwardRefExoticComponent<Omit<AlertDialog_2.AlertDialogDescriptionProps & React_2.RefAttributes<HTMLParagraphElement>, "ref"> & React_2.RefAttributes<HTMLParagraphElement>>;

declare const AlertDialogFooter: {
    ({ className, ...props }: React_2.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const AlertDialogHeader: {
    ({ className, ...props }: React_2.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const AlertDialogTitle: React_2.ForwardRefExoticComponent<Omit<AlertDialog_2.AlertDialogTitleProps & React_2.RefAttributes<HTMLHeadingElement>, "ref"> & React_2.RefAttributes<HTMLHeadingElement>>;

declare const AlertDialogTrigger: React_2.ForwardRefExoticComponent<AlertDialog_2.AlertDialogTriggerProps & React_2.RefAttributes<HTMLButtonElement>>;

declare const AlertTitle: ForwardRefExoticComponent<HTMLAttributes<HTMLHeadingElement> & RefAttributes<HTMLParagraphElement>>;

declare interface APIContextType {
    isLoading: boolean;
    wrapAPICall: <T>(promise: Promise<T>) => Promise<T>;
    wrapXHRCall: <T>(xhrCreator: () => XMLHttpRequest, processResponse: (xhr: XMLHttpRequest) => T) => Promise<T>;
}

export declare const APIHandler: (baseUrl: string) => {
    createProject: (description: string, theme: string, siteBackground?: File | null) => Promise<Response>;
    createBlankProject: (description: string, theme: string, siteBackground?: File | null) => Promise<Response>;
    getProjects: () => Promise<Response>;
    getProjectMetadata: (projectName: string) => Promise<Response>;
    getSubdomains: (projectName: string) => Promise<Response>;
    allocateSubdomain: (projectName: string, subdomain: string) => Promise<Response>;
    updateSubdomain: (projectName: string, subdomain: string) => Promise<Response>;
    releaseSubdomain: (projectName: string, subdomain: string) => Promise<Response>;
    publishProject: (projectName: string, gitRef: string) => Promise<Response>;
    unpublishProject: (projectName: string) => Promise<Response>;
    tagCommit: (projectName: string, commitHash: string, tagName: string) => Promise<Response>;
    getComponentLibrary: () => Promise<Response>;
    addProjectComponent: (projectName: string, componentNamespace: string, componentName: string, layoutMetadata: any) => Promise<Response>;
    addProjectChart: (projectName: string, visualId: string, layoutMetadata: object) => Promise<Response>;
    updateProjectComponentLayoutMetadata: (projectName: string, componentId: string, layoutMetadata: any) => Promise<Response>;
    updateProjectComponentSourceCode: (projectName: string, componentId: string, sourceCode: string) => Promise<Response>;
    updateApplicationMetadata: (projectName: string, applicationName: string, applicationDescription: string, applicationCategory: string) => Promise<Response>;
    updateApplicationSettings: (projectName: string, applicationLoginEnabled?: boolean | null, defaultDeploymentChainReference?: string | null) => Promise<Response>;
    updateProjectFile: (filePath: string, projectName: string, sourceCode: string, abortSignal?: AbortSignal) => Promise<Response>;
    updateProjectFiles: (files: [{
        projectName: string;
        filePath: string;
        fileContent: string;
    }], abortSignal?: AbortSignal) => Promise<Response>;
    deleteProjectComponent: (projectName: string, filePath: string) => Promise<Response>;
    deleteProjectFile: (projectName: string, filePath: string) => Promise<Response>;
    resetProjectFile: (projectName: string, filePath: string, gitRef: string, prune?: boolean, extraMetadata?: string) => Promise<Response>;
    deleteProject: (projectName: string) => Promise<Response>;
    requestErrorCorrection: (projectName: string, componentId: string, errorMessage: string) => Promise<Response>;
    addImage: (formData: FormData) => Promise<Response>;
    initializeProject: (projectName: string) => Promise<Response>;
};

export declare const APIProxyHandler: (baseUrl: string) => {
    getSecrets: () => Promise<Response>;
    putSecret: (secretReference: string, secret: Omit<Secret, "creator_user_id" | "secret_reference">) => Promise<Response>;
    getSecret: (secretReference: string) => Promise<Response>;
    deleteSecret: (secretReference: string) => Promise<Response>;
    getTierKeyMap: (miniappName: string) => Promise<Response>;
    putTierKeyMap: (miniappName: string, tier: string, secretReference: string) => Promise<Response>;
    getTierKeyMapForTier: (miniappName: string, tier: string) => Promise<Response>;
    deleteTierKeyMap: (miniappName: string, tier: string) => Promise<Response>;
    getTierAssignments: (miniappName: string) => Promise<Response>;
    putTierAssignment: (miniappName: string, userId: string, tier: string) => Promise<Response>;
    getTierAssignment: (miniappName: string, userId: string) => Promise<Response>;
    deleteTierAssignment: (miniappName: string, userId: string) => Promise<Response>;
    getRateLimits: (miniappName: string) => Promise<Response>;
    putRateLimit: (miniappName: string, tier: string, secretReference: string, rateLimit: Pick<RateLimit, "window_ms" | "limit">) => Promise<Response>;
    getRateLimit: (miniappName: string, tier: string, secretReference: string) => Promise<Response>;
    deleteRateLimit: (miniappName: string, tier: string, secretReference: string) => Promise<Response>;
    createProxyFetch: (config: ProxyFetchConfig) => (input: RequestInfo | URL, init?: RequestInit) => Promise<Response>;
    createProxyGetView: (config: ProxyGetViewConfig) => (schema: string, viewName: string, parameters?: {
        [key: string]: string | number | boolean;
    }) => Promise<{
        [key: string]: any;
    }[]>;
};

export declare const applySxtIgnore: (files: string[], pfs: any, dir: string) => Promise<string[]>;

declare const AspectRatio: ForwardRefExoticComponent<AspectRatio_2.AspectRatioProps & RefAttributes<HTMLDivElement>>;

declare const Avatar: React_2.ForwardRefExoticComponent<Omit<Avatar_2.AvatarProps & React_2.RefAttributes<HTMLSpanElement>, "ref"> & React_2.RefAttributes<HTMLSpanElement>>;

declare const AvatarFallback: React_2.ForwardRefExoticComponent<Omit<Avatar_2.AvatarFallbackProps & React_2.RefAttributes<HTMLSpanElement>, "ref"> & React_2.RefAttributes<HTMLSpanElement>>;

declare const AvatarImage: React_2.ForwardRefExoticComponent<Omit<Avatar_2.AvatarImageProps & React_2.RefAttributes<HTMLImageElement>, "ref"> & React_2.RefAttributes<HTMLImageElement>>;

declare function Badge({ className, variant, ...props }: BadgeProps): JSX_2.Element;

declare interface BadgeProps extends React.HTMLAttributes<HTMLDivElement>, VariantProps<typeof badgeVariants> {
}

declare const badgeVariants: (props?: ({
    variant?: "default" | "destructive" | "secondary" | "outline" | null | undefined;
} & ClassProp) | undefined) => string;

declare const Breadcrumb: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLElement> & React_2.RefAttributes<HTMLElement>>;

declare const BreadcrumbItem: React_2.ForwardRefExoticComponent<React_2.LiHTMLAttributes<HTMLLIElement> & React_2.RefAttributes<HTMLLIElement>>;

declare const BreadcrumbLink: React_2.ForwardRefExoticComponent<React_2.AnchorHTMLAttributes<HTMLAnchorElement> & React_2.RefAttributes<HTMLAnchorElement>>;

declare const BreadcrumbList: React_2.ForwardRefExoticComponent<React_2.OlHTMLAttributes<HTMLOListElement> & React_2.RefAttributes<HTMLOListElement>>;

declare const BreadcrumbPage: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLSpanElement> & React_2.RefAttributes<HTMLSpanElement>>;

declare const BreadcrumbSeparator: {
    ({ className, ...props }: React_2.ComponentProps<"li">): JSX_2.Element;
    displayName: string;
};

declare const Button: ForwardRefExoticComponent<ButtonProps & RefAttributes<HTMLButtonElement>>;

declare interface ButtonProps extends React.ButtonHTMLAttributes<HTMLButtonElement>, VariantProps<typeof buttonVariants> {
    asChild?: boolean;
}

declare const buttonVariants: (props?: ({
    variant?: "link" | "default" | "destructive" | "secondary" | "outline" | "ghost" | null | undefined;
    size?: "default" | "lg" | "sm" | "icon" | null | undefined;
} & ClassProp) | undefined) => string;

declare function Calendar({ className, classNames, showOutsideDays, ...props }: CalendarProps): JSX_2.Element;

declare namespace Calendar {
    var displayName: string;
}

declare type CalendarProps = React.ComponentProps<typeof DayPicker>;

declare const Card: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>>;

declare const CardContent: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>>;

declare const CardDescription: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLParagraphElement> & React_2.RefAttributes<HTMLParagraphElement>>;

declare const CardFooter: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>>;

declare const CardHeader: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>>;

declare const CardTitle: React_2.ForwardRefExoticComponent<React_2.HTMLAttributes<HTMLHeadingElement> & React_2.RefAttributes<HTMLParagraphElement>>;

declare const Carousel: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & CarouselProps & RefAttributes<HTMLDivElement>>;

declare const CarouselContent: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const CarouselItem: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const CarouselNext: ForwardRefExoticComponent<Omit<ButtonProps_2 & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const CarouselPrevious: ForwardRefExoticComponent<Omit<ButtonProps_2 & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare type CarouselProps = {
    opts?: Parameters<typeof default_3>[0];
    plugins?: Parameters<typeof default_3>[1];
    orientation?: "horizontal" | "vertical";
    setApi?: (api: NonNullable<ReturnType<typeof default_3>[1]>) => void;
};

declare const Checkbox: ForwardRefExoticComponent<Omit<Checkbox_2.CheckboxProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

export declare const checkoutCommit: (projectName: string, commitHash: string) => Promise<void>;

declare const Collapsible: ForwardRefExoticComponent<Collapsible_2.CollapsibleProps & RefAttributes<HTMLDivElement>>;

declare const CollapsibleContent: ForwardRefExoticComponent<Omit<Collapsible_2.CollapsibleContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const CollapsibleTrigger: ForwardRefExoticComponent<Collapsible_2.CollapsibleTriggerProps & RefAttributes<HTMLButtonElement>>;

declare function Combobox({ options, value, onValueChange, placeholder, emptyText, className, }: ComboboxProps): JSX_2.Element;

declare interface ComboboxProps {
    options: {
        label: string;
        value: string;
    }[];
    value?: string;
    onValueChange?: (value: string) => void;
    placeholder?: string;
    emptyText?: string;
    className?: string;
}

declare const Command: React_2.ForwardRefExoticComponent<Omit<{
    children?: React_2.ReactNode;
} & React_2.HTMLAttributes<HTMLDivElement> & {
    label?: string;
    shouldFilter?: boolean;
    filter?: (value: string, search: string) => number;
    defaultValue?: string;
    value?: string;
    onValueChange?: (value: string) => void;
    loop?: boolean;
    vimBindings?: boolean;
} & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandDialog: ({ children, ...props }: CommandDialogProps) => JSX_2.Element;

declare interface CommandDialogProps extends DialogProps {
}

declare const CommandEmpty: React_2.ForwardRefExoticComponent<Omit<{
    children?: React_2.ReactNode;
} & React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandGroup: React_2.ForwardRefExoticComponent<Omit<{
    children?: React_2.ReactNode;
} & Omit<React_2.HTMLAttributes<HTMLDivElement>, "value" | "heading"> & {
    heading?: React_2.ReactNode;
    value?: string;
    forceMount?: boolean;
} & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandInput: React_2.ForwardRefExoticComponent<Omit<Omit<React_2.InputHTMLAttributes<HTMLInputElement>, "type" | "value" | "onChange"> & {
    value?: string;
    onValueChange?: (search: string) => void;
} & React_2.RefAttributes<HTMLInputElement>, "ref"> & React_2.RefAttributes<HTMLInputElement>>;

declare const CommandItem: React_2.ForwardRefExoticComponent<Omit<{
    children?: React_2.ReactNode;
} & Omit<React_2.HTMLAttributes<HTMLDivElement>, "value" | "onSelect" | "disabled"> & {
    disabled?: boolean;
    onSelect?: (value: string) => void;
    value?: string;
    forceMount?: boolean;
} & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandList: React_2.ForwardRefExoticComponent<Omit<{
    children?: React_2.ReactNode;
} & React_2.HTMLAttributes<HTMLDivElement> & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandSeparator: React_2.ForwardRefExoticComponent<Omit<React_2.HTMLAttributes<HTMLDivElement> & {
    alwaysRender?: boolean;
} & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const CommandShortcut: {
    ({ className, ...props }: React_2.HTMLAttributes<HTMLSpanElement>): JSX_2.Element;
    displayName: string;
};

declare interface Commit {
    hash: string;
    timestamp: number;
    message: string;
    isRelease: boolean;
}

declare const ContextMenu: FC<ContextMenu_2.ContextMenuProps>;

declare const ContextMenuCheckboxItem: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuCheckboxItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ContextMenuContent: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ContextMenuGroup: ForwardRefExoticComponent<ContextMenu_2.ContextMenuGroupProps & RefAttributes<HTMLDivElement>>;

declare const ContextMenuItem: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuItemProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const ContextMenuLabel: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuLabelProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const ContextMenuPortal: FC<ContextMenu_2.ContextMenuPortalProps>;

declare const ContextMenuRadioGroup: ForwardRefExoticComponent<ContextMenu_2.ContextMenuRadioGroupProps & RefAttributes<HTMLDivElement>>;

declare const ContextMenuRadioItem: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuRadioItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ContextMenuSeparator: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuSeparatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ContextMenuShortcut: {
    ({ className, ...props }: React.HTMLAttributes<HTMLSpanElement>): JSX_2.Element;
    displayName: string;
};

declare const ContextMenuSub: FC<ContextMenu_2.ContextMenuSubProps>;

declare const ContextMenuSubContent: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuSubContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ContextMenuSubTrigger: ForwardRefExoticComponent<Omit<ContextMenu_2.ContextMenuSubTriggerProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const ContextMenuTrigger: ForwardRefExoticComponent<ContextMenu_2.ContextMenuTriggerProps & RefAttributes<HTMLSpanElement>>;

declare function DataTable<TData, TValue>({ columns, data, virtualizeRows, }: DataTableProps<TData, TValue>): JSX_2.Element;

declare interface DataTableProps<TData, TValue> {
    columns: ColumnDef<TData, TValue>[];
    data: TData[];
    virtualizeRows?: boolean;
}

declare function DatePicker({ date, onDateChange, placeholder, disabled, className, }: DatePickerProps): JSX_2.Element;

declare interface DatePickerProps {
    date?: Date;
    onDateChange?: (date?: Date) => void;
    placeholder?: string;
    disabled?: boolean;
    className?: string;
}

declare function DateRangePicker({ dateRange, onDateRangeChange, placeholder, disabled, className, }: DateRangePickerProps): JSX_2.Element;

declare interface DateRangePickerProps {
    dateRange?: {
        from?: Date;
        to?: Date;
    };
    onDateRangeChange?: (range: {
        from?: Date;
        to?: Date;
    }) => void;
    placeholder?: string;
    disabled?: boolean;
    className?: string;
}

declare const DEFAULT: {
    alert: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                destructive: string;
            };
        };
        defaultVariants: {
            variant: string;
        };
    };
    badge: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                secondary: string;
                destructive: string;
                outline: string;
            };
        };
        defaultVariants: {
            variant: string;
        };
    };
    button: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                primary: string;
                destructive: string;
                outline: string;
                secondary: string;
                ghost: string;
                link: string;
            };
            size: {
                default: string;
                sm: string;
                lg: string;
                icon: string;
            };
        };
        defaultVariants: {
            variant: string;
            size: string;
        };
    };
    sidebar: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                floating: string;
            };
            size: {
                default: string;
                sm: string;
                lg: string;
            };
            collapsed: {
                true: string;
                false: string;
            };
        };
        defaultVariants: {
            variant: string;
            size: string;
            collapsed: boolean;
        };
    };
    sidebarItem: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                ghost: string;
                active: string;
            };
        };
        defaultVariants: {
            variant: string;
        };
    };
    toggle: {
        defaultStyles: string;
        variantStyles: {
            variant: {
                default: string;
                outline: string;
            };
            size: {
                default: string;
                sm: string;
                lg: string;
            };
        };
        defaultVariants: {
            variant: string;
            size: string;
        };
    };
};

declare const Dialog_2: FC<Dialog.DialogProps>;

declare const DialogClose: ForwardRefExoticComponent<Dialog.DialogCloseProps & RefAttributes<HTMLButtonElement>>;

declare const DialogContent: ForwardRefExoticComponent<Omit<Dialog.DialogContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DialogDescription: ForwardRefExoticComponent<Omit<Dialog.DialogDescriptionProps & RefAttributes<HTMLParagraphElement>, "ref"> & RefAttributes<HTMLParagraphElement>>;

declare const DialogFooter: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const DialogHeader: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const DialogOverlay: ForwardRefExoticComponent<Omit<Dialog.DialogOverlayProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DialogPortal: FC<Dialog.DialogPortalProps>;

declare type DialogProps = React_2.ComponentProps<typeof Dialog.Root>;

declare const DialogTitle: ForwardRefExoticComponent<Omit<Dialog.DialogTitleProps & RefAttributes<HTMLHeadingElement>, "ref"> & RefAttributes<HTMLHeadingElement>>;

declare const DialogTrigger: ForwardRefExoticComponent<Dialog.DialogTriggerProps & RefAttributes<HTMLButtonElement>>;

declare const Drawer: {
    ({ shouldScaleBackground, ...props }: React.ComponentProps<typeof Drawer_2.Root>): JSX_2.Element;
    displayName: string;
};

declare const DrawerClose: ForwardRefExoticComponent<DialogCloseProps & RefAttributes<HTMLButtonElement>>;

declare const DrawerContent: ForwardRefExoticComponent<Omit<Omit<DialogContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DrawerDescription: ForwardRefExoticComponent<Omit<DialogDescriptionProps & RefAttributes<HTMLParagraphElement>, "ref"> & RefAttributes<HTMLParagraphElement>>;

declare const DrawerFooter: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const DrawerHeader: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const DrawerOverlay: ForwardRefExoticComponent<Omit<Omit<DialogOverlayProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DrawerPortal: Portal;

declare const DrawerTitle: ForwardRefExoticComponent<Omit<DialogTitleProps & RefAttributes<HTMLHeadingElement>, "ref"> & RefAttributes<HTMLHeadingElement>>;

declare const DrawerTrigger: ForwardRefExoticComponent<DialogTriggerProps & RefAttributes<HTMLButtonElement>>;

export declare namespace DreamspaceElements {
    export {
        useForm,
        Variants,
        Accordion,
        AccordionItem,
        AccordionTrigger,
        AccordionContent,
        Alert,
        AlertDescription,
        AlertTitle,
        AlertDialog,
        AlertDialogAction,
        AlertDialogCancel,
        AlertDialogContent,
        AlertDialogDescription,
        AlertDialogFooter,
        AlertDialogHeader,
        AlertDialogTitle,
        AlertDialogTrigger,
        AspectRatio,
        Avatar,
        AvatarFallback,
        AvatarImage,
        BadgeProps,
        Badge,
        badgeVariants,
        Breadcrumb,
        BreadcrumbItem,
        BreadcrumbLink,
        BreadcrumbList,
        BreadcrumbPage,
        BreadcrumbSeparator,
        ButtonProps,
        Button,
        buttonVariants,
        CalendarProps,
        Calendar,
        Card,
        CardContent,
        CardDescription,
        CardFooter,
        CardHeader,
        CardTitle,
        Carousel,
        CarouselContent,
        CarouselItem,
        CarouselNext,
        CarouselPrevious,
        UseEmblaCarouselType as CarouselApi,
        Checkbox,
        Collapsible,
        CollapsibleTrigger,
        CollapsibleContent,
        Combobox,
        Command,
        CommandDialog,
        CommandEmpty,
        CommandGroup,
        CommandInput,
        CommandItem,
        CommandList,
        CommandSeparator,
        CommandShortcut,
        ContextMenu,
        ContextMenuCheckboxItem,
        ContextMenuContent,
        ContextMenuGroup,
        ContextMenuItem,
        ContextMenuLabel,
        ContextMenuPortal,
        ContextMenuRadioGroup,
        ContextMenuRadioItem,
        ContextMenuSeparator,
        ContextMenuShortcut,
        ContextMenuSub,
        ContextMenuSubContent,
        ContextMenuSubTrigger,
        ContextMenuTrigger,
        DataTable,
        ColumnDef,
        ColumnFiltersState,
        SortingState,
        VisibilityState,
        DatePicker,
        DateRangePicker,
        Dialog_2 as Dialog,
        DialogClose,
        DialogContent,
        DialogDescription,
        DialogFooter,
        DialogHeader,
        DialogOverlay,
        DialogPortal,
        DialogTitle,
        DialogTrigger,
        Drawer,
        DrawerClose,
        DrawerContent,
        DrawerDescription,
        DrawerFooter,
        DrawerHeader,
        DrawerOverlay,
        DrawerPortal,
        DrawerTitle,
        DrawerTrigger,
        DropdownMenu,
        DropdownMenuCheckboxItem,
        DropdownMenuContent,
        DropdownMenuGroup,
        DropdownMenuItem,
        DropdownMenuLabel,
        DropdownMenuPortal,
        DropdownMenuRadioGroup,
        DropdownMenuRadioItem,
        DropdownMenuSeparator,
        DropdownMenuShortcut,
        DropdownMenuSub,
        DropdownMenuSubContent,
        DropdownMenuSubTrigger,
        DropdownMenuTrigger,
        Form,
        FormControl,
        FormDescription,
        FormField,
        FormItem,
        FormLabel,
        FormMessage,
        useFormField,
        HoverCard,
        HoverCardContent,
        HoverCardTrigger,
        InputProps,
        Input,
        Label_2 as Label,
        Menubar,
        MenubarCheckboxItem,
        MenubarContent,
        MenubarGroup,
        MenubarItem,
        MenubarLabel,
        MenubarMenu,
        MenubarPortal,
        MenubarRadioGroup,
        MenubarRadioItem,
        MenubarSeparator,
        MenubarShortcut,
        MenubarSub,
        MenubarSubContent,
        MenubarSubTrigger,
        MenubarTrigger,
        NavigationMenu,
        NavigationMenuContent,
        NavigationMenuIndicator,
        NavigationMenuItem,
        NavigationMenuLink,
        NavigationMenuList,
        NavigationMenuTrigger,
        navigationMenuTriggerStyle,
        NavigationMenuViewport,
        Pagination,
        PaginationContent,
        PaginationEllipsis,
        PaginationFirst,
        PaginationItem,
        PaginationLast,
        PaginationLink,
        PaginationNext,
        PaginationPrevious,
        Popover,
        PopoverContent,
        PopoverTrigger,
        Progress,
        RadioGroup,
        RadioGroupItem,
        ResizableHandle,
        ResizablePanel,
        ResizablePanelGroup,
        ScrollArea,
        ScrollBar,
        Select,
        SelectContent,
        SelectGroup,
        SelectItem,
        SelectLabel,
        SelectScrollDownButton,
        SelectScrollUpButton,
        SelectSeparator,
        SelectTrigger,
        SelectValue,
        Separator,
        Sheet,
        SheetClose,
        SheetContent,
        SheetDescription,
        SheetFooter,
        SheetHeader,
        SheetOverlay,
        SheetPortal,
        SheetTitle,
        SheetTrigger,
        SidebarItemProps,
        Sidebar,
        SidebarFooter,
        SidebarGroup,
        SidebarHeader,
        SidebarItem,
        SidebarNav,
        Skeleton,
        Slider,
        Toaster,
        Switch,
        Table,
        TableBody,
        TableCaption,
        TableCell,
        TableFooter,
        TableHead,
        TableHeader,
        TableRow,
        Tabs,
        TabsContent,
        TabsList,
        TabsTrigger,
        TextareaProps,
        Textarea,
        Toggle,
        toggleVariants,
        ToggleGroup,
        ToggleGroupItem,
        Tooltip,
        TooltipContent,
        TooltipProvider,
        TooltipTrigger
    }
}

declare const DropdownMenu: FC<DropdownMenu_2.DropdownMenuProps>;

declare const DropdownMenuCheckboxItem: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuCheckboxItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuContent: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuGroup: ForwardRefExoticComponent<DropdownMenu_2.DropdownMenuGroupProps & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuItem: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuItemProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuLabel: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuLabelProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuPortal: FC<DropdownMenu_2.DropdownMenuPortalProps>;

declare const DropdownMenuRadioGroup: ForwardRefExoticComponent<DropdownMenu_2.DropdownMenuRadioGroupProps & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuRadioItem: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuRadioItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuSeparator: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuSeparatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuShortcut: {
    ({ className, ...props }: React.HTMLAttributes<HTMLSpanElement>): JSX_2.Element;
    displayName: string;
};

declare const DropdownMenuSub: FC<DropdownMenu_2.DropdownMenuSubProps>;

declare const DropdownMenuSubContent: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuSubContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuSubTrigger: ForwardRefExoticComponent<Omit<DropdownMenu_2.DropdownMenuSubTriggerProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const DropdownMenuTrigger: ForwardRefExoticComponent<DropdownMenu_2.DropdownMenuTriggerProps & RefAttributes<HTMLButtonElement>>;

declare const Form: <TFieldValues extends FieldValues, TContext = any, TTransformedValues extends FieldValues | undefined = undefined>(props: FormProviderProps<TFieldValues, TContext, TTransformedValues>) => React.JSX.Element;

declare const FormControl: ForwardRefExoticComponent<Omit<SlotProps & RefAttributes<HTMLElement>, "ref"> & RefAttributes<HTMLElement>>;

declare const FormDescription: ForwardRefExoticComponent<HTMLAttributes<HTMLParagraphElement> & RefAttributes<HTMLParagraphElement>>;

declare const FormField: <TFieldValues extends FieldValues = FieldValues, TName extends FieldPath<TFieldValues> = FieldPath<TFieldValues>>({ ...props }: ControllerProps<TFieldValues, TName>) => JSX_2.Element;

declare const FormItem: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const FormLabel: ForwardRefExoticComponent<Omit<Label.LabelProps & RefAttributes<HTMLLabelElement>, "ref"> & RefAttributes<HTMLLabelElement>>;

declare const FormMessage: ForwardRefExoticComponent<HTMLAttributes<HTMLParagraphElement> & RefAttributes<HTMLParagraphElement>>;

export declare const getCommits: (projectName: string, projectUrl: string, commitsCount?: number) => Promise<Commit[]>;

export declare const getHeadCommit: (projectName: string) => Promise<string>;

export declare const getRedoTargetCommitForFile: (projectName: string, filePath: string) => Promise<[string, string]>;

export declare const getTags: (projectName: string, projectUrl: string, { fetch }?: GetTagsOptions) => Promise<{
    tag: string;
    targetCommitTimestamp: number;
    targetCommit: string;
    ref: string;
}[]>;

declare type GetTagsOptions = {
    fetch?: boolean;
};

export declare const getUndoTargetCommitForFile: (projectName: string, filePath: string) => Promise<[string, string]>;

declare const HoverCard: FC<HoverCard_2.HoverCardProps>;

declare const HoverCardContent: ForwardRefExoticComponent<Omit<HoverCard_2.HoverCardContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const HoverCardTrigger: ForwardRefExoticComponent<HoverCard_2.HoverCardTriggerProps & RefAttributes<HTMLAnchorElement>>;

export declare const initializeMakeInfinite: () => void;

declare const Input: ForwardRefExoticComponent<InputProps & RefAttributes<HTMLInputElement>>;

declare interface InputProps extends React.InputHTMLAttributes<HTMLInputElement> {
}

declare const Label_2: ForwardRefExoticComponent<Omit<Label.LabelProps & RefAttributes<HTMLLabelElement>, "ref"> & VariantProps<(props?: ClassProp | undefined) => string> & RefAttributes<HTMLLabelElement>>;

export declare const listAllFiles: (projectName: string, repoURL: string) => Promise<never[] | string[]>;

export declare const listDir: (dirPath: string) => Promise<any>;

export declare const loadLibraryComponents: (apiHandler: any) => Promise<any>;

export declare const loadProjectComponents: (projectName: string) => Promise<{
    components: any;
    layout: any;
}>;

declare const Menubar: ForwardRefExoticComponent<Omit<Menubar_2.MenubarProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarCheckboxItem: ForwardRefExoticComponent<Omit<Menubar_2.MenubarCheckboxItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarContent: ForwardRefExoticComponent<Omit<Menubar_2.MenubarContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarGroup: ForwardRefExoticComponent<Menubar_2.MenubarGroupProps & RefAttributes<HTMLDivElement>>;

declare const MenubarItem: ForwardRefExoticComponent<Omit<Menubar_2.MenubarItemProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const MenubarLabel: ForwardRefExoticComponent<Omit<Menubar_2.MenubarLabelProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const MenubarMenu: {
    (props: Menubar_2.MenubarMenuProps & {
        __scopeMenubar?: Scope;
    }): JSX_2.Element;
    displayName: string;
};

declare const MenubarPortal: FC<Menubar_2.MenubarPortalProps>;

declare const MenubarRadioGroup: ForwardRefExoticComponent<Menubar_2.MenubarRadioGroupProps & RefAttributes<HTMLDivElement>>;

declare const MenubarRadioItem: ForwardRefExoticComponent<Omit<Menubar_2.MenubarRadioItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarSeparator: ForwardRefExoticComponent<Omit<Menubar_2.MenubarSeparatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarShortcut: {
    ({ className, ...props }: React.HTMLAttributes<HTMLSpanElement>): JSX_2.Element;
    displayName: string;
};

declare const MenubarSub: FC<Menubar_2.MenubarSubProps>;

declare const MenubarSubContent: ForwardRefExoticComponent<Omit<Menubar_2.MenubarSubContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const MenubarSubTrigger: ForwardRefExoticComponent<Omit<Menubar_2.MenubarSubTriggerProps & RefAttributes<HTMLDivElement>, "ref"> & {
inset?: boolean;
} & RefAttributes<HTMLDivElement>>;

declare const MenubarTrigger: ForwardRefExoticComponent<Omit<Menubar_2.MenubarTriggerProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

export declare const MiniApp: () => JSX_2.Element;

declare const NavigationMenu: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuProps & RefAttributes<HTMLElement>, "ref"> & RefAttributes<HTMLElement>>;

declare const NavigationMenuContent: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const NavigationMenuIndicator: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuIndicatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const NavigationMenuItem: ForwardRefExoticComponent<NavigationMenu_2.NavigationMenuItemProps & RefAttributes<HTMLLIElement>>;

declare const NavigationMenuLink: ForwardRefExoticComponent<NavigationMenu_2.NavigationMenuLinkProps & RefAttributes<HTMLAnchorElement>>;

declare const NavigationMenuList: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuListProps & RefAttributes<HTMLUListElement>, "ref"> & RefAttributes<HTMLUListElement>>;

declare const NavigationMenuTrigger: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuTriggerProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const navigationMenuTriggerStyle: (props?: ClassProp | undefined) => string;

declare const NavigationMenuViewport: ForwardRefExoticComponent<Omit<NavigationMenu_2.NavigationMenuViewportProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const Pagination: {
    ({ className, ...props }: React.ComponentProps<"nav">): JSX_2.Element;
    displayName: string;
};

declare const PaginationContent: ForwardRefExoticComponent<Omit<DetailedHTMLProps<HTMLAttributes<HTMLUListElement>, HTMLUListElement>, "ref"> & RefAttributes<HTMLUListElement>>;

declare const PaginationEllipsis: {
    ({ className, ...props }: React.ComponentProps<"span">): JSX_2.Element;
    displayName: string;
};

declare const PaginationFirst: ForwardRefExoticComponent<Omit<Omit<PaginationLinkProps, "ref"> & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const PaginationItem: ForwardRefExoticComponent<Omit<DetailedHTMLProps<LiHTMLAttributes<HTMLLIElement>, HTMLLIElement>, "ref"> & RefAttributes<HTMLLIElement>>;

declare const PaginationLast: ForwardRefExoticComponent<Omit<Omit<PaginationLinkProps, "ref"> & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const PaginationLink: ForwardRefExoticComponent<Omit<PaginationLinkProps, "ref"> & RefAttributes<HTMLButtonElement>>;

declare type PaginationLinkProps = {
    isActive?: boolean;
    disabled?: boolean;
} & Pick<ButtonProps, "size"> & React.ComponentProps<"button">;

declare const PaginationNext: ForwardRefExoticComponent<Omit<Omit<PaginationLinkProps, "ref"> & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const PaginationPrevious: ForwardRefExoticComponent<Omit<Omit<PaginationLinkProps, "ref"> & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const Popover: FC<Popover_2.PopoverProps>;

declare const PopoverContent: ForwardRefExoticComponent<Omit<Popover_2.PopoverContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const PopoverTrigger: ForwardRefExoticComponent<Popover_2.PopoverTriggerProps & RefAttributes<HTMLButtonElement>>;

declare const Progress: ForwardRefExoticComponent<Omit<Progress_2.ProgressProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

export declare const ProjectProvider: (props: {
    config: any;
    metadata?: any;
    children?: React.ReactNode;
}) => JSX_2.Element;

/** Configuration for the proxy fetch client */
declare type ProxyFetchConfig = {
    miniappName: string;
};

/** Configuration for the proxy getView client */
declare type ProxyGetViewConfig = {
    miniappName: string;
    gwProxyUrl: string;
};

declare const RadioGroup: ForwardRefExoticComponent<Omit<RadioGroup_2.RadioGroupProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const RadioGroupItem: ForwardRefExoticComponent<Omit<RadioGroup_2.RadioGroupItemProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

/** Represents rate limit configuration for a tier */
declare type RateLimit = {
    miniapp_name: string;
    secret_reference: string;
    tier: string;
    window_ms: number;
    limit: number;
};

declare const ResizableHandle: {
    ({ className, ...props }: PanelResizeHandleProps): JSX_2.Element;
    displayName: string;
};

declare const ResizablePanel: ForwardRefExoticComponent<Omit<PanelProps, "ref"> & RefAttributes<ImperativePanelHandle>>;

declare const ResizablePanelGroup: any;

export declare const RGComponent: default_2.ForwardRefExoticComponent<Omit<RGContainerProps, "ref"> & default_2.RefAttributes<HTMLDivElement>>;

export declare class RGComponentErrorBoundary<T> extends default_2.Component<RGComponentErrorBoundaryProps<T>, RGComponentErrorBoundaryState> {
    constructor(props: RGComponentErrorBoundaryProps<T>);
    static getDerivedStateFromError(error: Error): {
        hasError: boolean;
        error: Error;
    };
    render(): default_2.ReactNode;
    resetState(): void;
}

declare interface RGComponentErrorBoundaryProps<T> {
    children: default_2.ReactNode;
    fallback?: default_2.ComponentType<RGFallbackComponentProps & T>;
    fallbackProps?: T;
}

declare interface RGComponentErrorBoundaryState {
    hasError: boolean;
    error: Error | null;
}

declare interface RGContainerProps {
    style?: any;
    className?: string;
    onMouseDown?: any;
    onMouseUp?: any;
    onTouchEnd?: any;
    children?: default_2.ReactNode;
    [key: string]: any;
    componentId: any;
}

export declare const RGDroppable: (props: {
    id: string;
    type: string;
    initialSize: {
        w: number;
        h: number;
    };
    metadata: object;
    node: ReactNode;
}) => JSX_2.Element;

export declare const RGEditLayout: (props: {
    components: JSX.Element[];
    layouts: any;
    onLayoutChange: (layout: any) => void;
    onResizeStart: ItemCallback;
    onResizeStop: ItemCallback;
    onDragStart: ItemCallback;
    onDragStop: ItemCallback;
    onDrop: (layout: any, item: Layout, e: Event) => void;
    isDraggable: boolean;
    isResizable: boolean;
    isDroppable: boolean;
    disableResize: boolean;
}) => JSX_2.Element;

declare interface RGFallbackComponentProps {
    error: Error | null;
}

export declare const RGPreviewLayout: (props: {
    components: any;
    layouts: any;
}) => JSX_2.Element;

export declare const RGProvider: FC<PropsWithChildren<ReactNode>>;

declare const ScrollArea: ForwardRefExoticComponent<Omit<ScrollArea_2.ScrollAreaProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const ScrollBar: ForwardRefExoticComponent<Omit<ScrollArea_2.ScrollAreaScrollbarProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

/** Represents a secret configuration for API access */
declare type Secret = {
    creator_user_id: string;
    api_domain: string;
    api_path_prefix: string;
    auth_header_key: string;
    auth_header_value: string;
    secret_reference: string;
};

declare const Select: FC<Select_2.SelectProps>;

declare const SelectContent: ForwardRefExoticComponent<Omit<Select_2.SelectContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectGroup: ForwardRefExoticComponent<Select_2.SelectGroupProps & RefAttributes<HTMLDivElement>>;

declare const SelectItem: ForwardRefExoticComponent<Omit<Select_2.SelectItemProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectLabel: ForwardRefExoticComponent<Omit<Select_2.SelectLabelProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectScrollDownButton: ForwardRefExoticComponent<Omit<Select_2.SelectScrollDownButtonProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectScrollUpButton: ForwardRefExoticComponent<Omit<Select_2.SelectScrollUpButtonProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectSeparator: ForwardRefExoticComponent<Omit<Select_2.SelectSeparatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SelectTrigger: ForwardRefExoticComponent<Omit<Select_2.SelectTriggerProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

declare const SelectValue: ForwardRefExoticComponent<Select_2.SelectValueProps & RefAttributes<HTMLSpanElement>>;

declare const Separator: ForwardRefExoticComponent<Omit<Separator_2.SeparatorProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

export declare const setTailwindTheme: (theme: object) => void;

declare const Sheet: FC<Dialog.DialogProps>;

declare const SheetClose: ForwardRefExoticComponent<Dialog.DialogCloseProps & RefAttributes<HTMLButtonElement>>;

declare const SheetContent: ForwardRefExoticComponent<SheetContentProps & RefAttributes<HTMLDivElement>>;

declare interface SheetContentProps extends React.ComponentPropsWithoutRef<typeof Dialog.Content>, VariantProps<typeof sheetVariants> {
}

declare const SheetDescription: ForwardRefExoticComponent<Omit<Dialog.DialogDescriptionProps & RefAttributes<HTMLParagraphElement>, "ref"> & RefAttributes<HTMLParagraphElement>>;

declare const SheetFooter: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const SheetHeader: {
    ({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;
    displayName: string;
};

declare const SheetOverlay: ForwardRefExoticComponent<Omit<Dialog.DialogOverlayProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const SheetPortal: FC<Dialog.DialogPortalProps>;

declare const SheetTitle: ForwardRefExoticComponent<Omit<Dialog.DialogTitleProps & RefAttributes<HTMLHeadingElement>, "ref"> & RefAttributes<HTMLHeadingElement>>;

declare const SheetTrigger: ForwardRefExoticComponent<Dialog.DialogTriggerProps & RefAttributes<HTMLButtonElement>>;

declare const sheetVariants: (props?: ({
    side?: "top" | "right" | "bottom" | "left" | null | undefined;
} & ClassProp) | undefined) => string;

declare const Sidebar: ForwardRefExoticComponent<SidebarProps & RefAttributes<HTMLDivElement>>;

declare const SidebarFooter: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const SidebarGroup: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const SidebarHeader: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare const SidebarItem: ForwardRefExoticComponent<SidebarItemProps & RefAttributes<HTMLDivElement>>;

declare interface SidebarItemProps extends React.HTMLAttributes<HTMLDivElement>, VariantProps<typeof sidebarItemVariants> {
    icon?: React.ReactNode;
    badge?: React.ReactNode;
    active?: boolean;
}

declare const sidebarItemVariants: (props?: ({
    variant?: "default" | "ghost" | "active" | null | undefined;
} & ClassProp) | undefined) => string;

declare const SidebarNav: ForwardRefExoticComponent<HTMLAttributes<HTMLDivElement> & RefAttributes<HTMLDivElement>>;

declare interface SidebarProps extends React.HTMLAttributes<HTMLDivElement>, VariantProps<typeof sidebarVariants> {
    fixed?: boolean;
}

declare const sidebarVariants: (props?: ({
    variant?: "default" | "floating" | null | undefined;
    size?: "default" | "lg" | "sm" | null | undefined;
    collapsed?: boolean | null | undefined;
} & ClassProp) | undefined) => string;

declare function Skeleton({ className, ...props }: React.HTMLAttributes<HTMLDivElement>): JSX_2.Element;

declare const Slider: ForwardRefExoticComponent<Omit<Slider_2.SliderProps & RefAttributes<HTMLSpanElement>, "ref"> & RefAttributes<HTMLSpanElement>>;

declare const Switch: ForwardRefExoticComponent<Omit<Switch_2.SwitchProps & RefAttributes<HTMLButtonElement>, "ref"> & RefAttributes<HTMLButtonElement>>;

export declare const syncAndRetry: (projectName: string, projectRepository: string) => Promise<void>;

declare const Table: ForwardRefExoticComponent<HTMLAttributes<HTMLTableElement> & RefAttributes<HTMLTableElement>>;

declare const TableBody: ForwardRefExoticComponent<HTMLAttributes<HTMLTableSectionElement> & RefAttributes<HTMLTableSectionElement>>;

declare const TableCaption: ForwardRefExoticComponent<HTMLAttributes<HTMLTableCaptionElement> & RefAttributes<HTMLTableCaptionElement>>;

declare const TableCell: ForwardRefExoticComponent<TdHTMLAttributes<HTMLTableCellElement> & RefAttributes<HTMLTableCellElement>>;

declare const TableFooter: ForwardRefExoticComponent<HTMLAttributes<HTMLTableSectionElement> & RefAttributes<HTMLTableSectionElement>>;

declare const TableHead: ForwardRefExoticComponent<ThHTMLAttributes<HTMLTableCellElement> & RefAttributes<HTMLTableCellElement>>;

declare const TableHeader: ForwardRefExoticComponent<HTMLAttributes<HTMLTableSectionElement> & RefAttributes<HTMLTableSectionElement>>;

declare const TableRow: ForwardRefExoticComponent<HTMLAttributes<HTMLTableRowElement> & RefAttributes<HTMLTableRowElement>>;

declare const Tabs: React_2.ForwardRefExoticComponent<Tabs_2.TabsProps & React_2.RefAttributes<HTMLDivElement>>;

declare const TabsContent: React_2.ForwardRefExoticComponent<Omit<Tabs_2.TabsContentProps & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const TabsList: React_2.ForwardRefExoticComponent<Omit<Tabs_2.TabsListProps & React_2.RefAttributes<HTMLDivElement>, "ref"> & React_2.RefAttributes<HTMLDivElement>>;

declare const TabsTrigger: React_2.ForwardRefExoticComponent<Omit<Tabs_2.TabsTriggerProps & React_2.RefAttributes<HTMLButtonElement>, "ref"> & React_2.RefAttributes<HTMLButtonElement>>;

declare const TailwindThemeConsumer: Consumer<any>;

export declare namespace TailwindThemeContext {
    export {
        TailwindThemeContext_2 as TailwindThemeContext,
        TailwindThemeConsumer,
        TailwindThemeProvider
    }
}

declare const TailwindThemeContext_2: Context<any>;

export declare namespace TailwindThemeHooks {
    export {
        useVariants,
        useTheme,
        useFontFamily,
        useColors,
        useSiteBackground,
        useTailwind
    }
}

declare const TailwindThemeProvider: (props: {
    children?: React.ReactNode;
}) => JSX_2.Element;

declare const Textarea: ForwardRefExoticComponent<TextareaProps & RefAttributes<HTMLTextAreaElement>>;

declare interface TextareaProps extends React.TextareaHTMLAttributes<HTMLTextAreaElement> {
}

declare const Toaster: ({ ...props }: ToasterProps) => JSX_2.Element;

declare type ToasterProps = React.ComponentProps<typeof Toaster_2>;

declare const Toggle: ForwardRefExoticComponent<Omit<TogglePrimitive.ToggleProps & RefAttributes<HTMLButtonElement>, "ref"> & VariantProps<(props?: ({
variant?: "default" | "outline" | null | undefined;
size?: "default" | "lg" | "sm" | null | undefined;
} & ClassProp) | undefined) => string> & RefAttributes<HTMLButtonElement>>;

declare const ToggleGroup: ForwardRefExoticComponent<((Omit<ToggleGroupPrimitive.ToggleGroupSingleProps & RefAttributes<HTMLDivElement>, "ref"> | Omit<ToggleGroupPrimitive.ToggleGroupMultipleProps & RefAttributes<HTMLDivElement>, "ref">) & VariantProps<(props?: ({
variant?: "default" | "outline" | null | undefined;
size?: "default" | "lg" | "sm" | null | undefined;
} & ClassProp) | undefined) => string>) & RefAttributes<HTMLDivElement>>;

declare const ToggleGroupItem: ForwardRefExoticComponent<Omit<ToggleGroupPrimitive.ToggleGroupItemProps & RefAttributes<HTMLButtonElement>, "ref"> & VariantProps<(props?: ({
variant?: "default" | "outline" | null | undefined;
size?: "default" | "lg" | "sm" | null | undefined;
} & ClassProp) | undefined) => string> & RefAttributes<HTMLButtonElement>>;

declare const toggleVariants: (props?: ({
    variant?: "default" | "outline" | null | undefined;
    size?: "default" | "lg" | "sm" | null | undefined;
} & ClassProp) | undefined) => string;

declare const Tooltip: FC<TooltipPrimitive.TooltipProps>;

declare const TooltipContent: ForwardRefExoticComponent<Omit<TooltipPrimitive.TooltipContentProps & RefAttributes<HTMLDivElement>, "ref"> & RefAttributes<HTMLDivElement>>;

declare const TooltipProvider: FC<TooltipPrimitive.TooltipProviderProps>;

declare const TooltipTrigger: ForwardRefExoticComponent<TooltipPrimitive.TooltipTriggerProps & RefAttributes<HTMLButtonElement>>;

export declare const useAPI: () => APIContextType;

export declare const useAppMetadata: (projectName: string, deps?: any[]) => any;

export declare const useAppSettings: (projectName: string, deps?: any[]) => any;

export declare const useAppVersions: (projectName: string, projectURL: string, deps?: any[]) => any;

export declare const useB64UrlForProjectImage: (projectName: string, imageFilename: string) => string;

declare const useColors: () => {
    colors: any;
    setColors: (colors: Record<string, any>) => void;
};

declare const useFontFamily: () => {
    fontFamily: any;
    setFontFamily: (fontFamily: string) => void;
};

declare const useFormField: () => {
    invalid: boolean;
    isDirty: boolean;
    isTouched: boolean;
    isValidating: boolean;
    error?: FieldError;
    id: string;
    name: string;
    formItemId: string;
    formDescriptionId: string;
    formMessageId: string;
};

export declare const useProject: () => any;

export declare const useRGContext: () => any;

declare const useSiteBackground: () => {
    siteBackground: any;
    siteBackgroundColor: any;
    siteBackgroundImage: any;
    setSiteBackground: any;
};

declare const useTailwind: () => {
    tailwind: any;
    setTailwind: any;
};

declare const useTheme: () => {
    theme: any;
    setTheme: any;
};

declare const useVariants: () => {
    variants: any;
    setVariants: any;
};

/**
 * Hook for managing a WebSocket connection with automatic reconnection
 *
 * @param getUrl Function that returns the WebSocket URL to connect to (return null to prevent connection)
 * @param onMessageReceived Callback function to handle received messages
 * @param options Connection options
 */
export declare const useWebSocketManager: (getUrl: () => string | null, onMessageReceived: (data: any) => void, options?: WebSocketOptions) => UseWebSocketManagerReturn;

/**
 * Return type for useWebSocketManager hook
 */
declare interface UseWebSocketManagerReturn {
    /** Current connection status */
    connectionStatus: WebSocketStatus;
    /** Function to send messages over the WebSocket */
    sendMessage: (message: object) => boolean;
    /** Most recent error during connection or message handling */
    lastError: Error | null;
}

export declare namespace Variants {
    export {
        DEFAULT
    }
}

/**
 * Options for WebSocket connection management
 */
declare interface WebSocketOptions {
    /** Maximum number of reconnection attempts (default: 5) */
    maxReconnectAttempts?: number;
    /** Initial delay in ms before first reconnection attempt (default: 1000) */
    reconnectInitialDelay?: number;
    /** Exponential backoff factor for subsequent reconnect attempts (default: 2) */
    reconnectBackoffFactor?: number;
}

/**
 * WebSocket connection status
 */
declare type WebSocketStatus = "idle" | "connecting" | "open" | "closing" | "closed";

export { }


declare global {
    interface Window {
        fs: any;
        pfs: any;
        miDir: string;
        Buffer: typeof Buffer;
        ethers: any;
        MakeInfinite: any;
        ReactECharts: any;
        THREE: any;
        Radix: any;
        DreamspaceElements: any;
        Lucide: any;
    }
}


declare namespace Calendar {
    var displayName: string;
}
